/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 7/15/2006; 1:06:06 PM

#include "All.h"


#define FILE_SIZE (sizeof(SaveFile)+50)
#define FILE_NAME "kartsav"
#define FILE_TYPE "SAV"
	
/*

*/
char createFile() {
	SYM_ENTRY *sym;
	HANDLE handle;	
	char *ptrFILE;
	handle=HeapAlloc(FILE_SIZE);
	if(!handle) return(FALSE);
	sym=DerefSym(SymAdd(SYMSTR(FILE_NAME)));
	if(!sym) {HeapFree(handle); return(FALSE);}
	sym->handle=handle;
	ptrFILE=HeapDeref(handle);
	*(short*)ptrFILE=FILE_SIZE-2;
	ptrFILE[FILE_SIZE-6]=0;
	strcpy(ptrFILE+FILE_SIZE-5,FILE_TYPE);
	ptrFILE[FILE_SIZE-1]=OTH_TAG;	
	return(TRUE);


}

/*

*/	
SaveFile* getFilePtrToSave() {
	SYM_ENTRY *sym = SymFindPtr(SYMSTR(FILE_NAME),0);
	return (SaveFile*)(((char*)HeapDeref(sym->handle))+2);
}

/*

*/
void initNewFile() {
	int i;
	SaveFile* sf = getFilePtrToSave();
	for (i=NUMBER_OF_MAP;i--;) {
		sf->scores[i].bestLap = 9999;
		sf->scores[i].best3Laps = 9999;	
		sf->scores[i].attemps = 0;
		sf->scores[i].laps = 0;
		memset(&(sf->ghostSave[i]),0,sizeof(GhostSave));
	}
	sf->wantToShowGhost = TRUE;
}

/*

*/
char fileExists() {
	return SymFindPtr(SYMSTR(FILE_NAME),0)!=0;
}

