/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 4/27/2006; 1:43:15 AM

#include "All.h"


/*
	This function transforms 16x14 tiles (28 bytes) into expanded 16x16 tiles (256 bytes)
*/
void decompressTiles() {
	ST_helpMsg("Expanding graphics...");
	short i,j,k;
	unsigned short *ptr=allocatedMem->decompressedTiles->data;
	unsigned const short *ptr2=compressedTile;
	memset(ptr,0,sizeof(DecompressedTiles));
	for (i=0;i<NUMBER_OF_TILES;i++) {
		ptr+=2*16;
		for (j=0;j<12;j++) {
			ptr+=2;
			for (k=2;k<14;k++) {
				if ((*ptr2)&(4<<k)) {
					*ptr=0xffff;
				}
				ptr++;
			}
			ptr+=2;
			ptr2++;
		}
		ptr+=(2*16);
	}
}


/*
	similar
*/
void decompressMasks() {
	ST_helpMsg("Expanding graphics...");
	short i;
	unsigned short *dest=allocatedMem->decompressedMasks->data;
	unsigned short *src=(unsigned short *)compressedMask;
	memset(dest,0,sizeof(DecompressedMasks));
	for (i=0;i<NUMBER_OF_TILES;i++) {
		memcpy((char*)dest,(char*)src,12*2);
		dest+=16;
		src+=12;
	}
	//ClrScr();	
	//Sprite16_RPLC_R(0,0,130,&(allocatedMem->decompressedMasks->data[7*16]),LCD_MEM);
	//while(1);
}
